import { defineComponent as D, openBlock as c, createElementBlock as h, createElementVNode as d, renderSlot as v, mergeModels as U, useModel as w, watch as V, useSlots as N, ref as k, onMounted as O, Fragment as P, renderList as x, createVNode as A, withCtx as S, unref as Y, createTextVNode as $, toDisplayString as E, createCommentVNode as L, createBlock as F, resolveDynamicComponent as H } from "vue";
import * as e from "leaflet";
class M extends e.Control {
  // Optional 'cause it's initialized in `addTo`
  constructor(a, t) {
    if (super(t), this.options = {
      panelPosition: "left",
      hasTabs: !0,
      tabsPosition: "top",
      darkMode: !1,
      pushControls: !1,
      defaultTab: 1,
      onTabClick: () => {
      },
      onToggle: () => {
      },
      ...t
      // Merge with default options
    }, t != null && t.position) {
      const s = "Leaflet.SidePanel: You cannot set the `position` option. It is controlled by the `panelPosition` option.";
      t != null && t.panelPosition ? console.warn(s) : console.error(s);
    }
    this._panel = e.DomUtil.get(a), e.setOptions(this, t);
  }
  addTo(a) {
    return this._map = a, e.DomUtil.addClass(this._panel, "sidepanel-" + this.options.panelPosition), this.options.darkMode && e.DomUtil.addClass(this._panel, "sidepanel-dark"), e.DomEvent.disableScrollPropagation(this._panel), e.DomEvent.disableClickPropagation(this._panel), this.options.hasTabs ? this._initTabs(this.options.tabsPosition) : this._initContent(), this;
  }
  // Define the private methods as part of the class
  _initContent() {
    this._toggleButton();
  }
  _initTabs(a) {
    typeof a == "string" && e.DomUtil.addClass(this._panel, "tabs-" + a);
    const t = this._panel.querySelectorAll(
      "a.sidebar-tab-link"
    ), s = this._panel.querySelectorAll(
      ".sidepanel-tab-content"
    );
    t.forEach((o, l) => {
      let n, m;
      typeof this.options.defaultTab == "number" && this.options.defaultTab - 1 === l && (n = o, m = s[l]), typeof this.options.defaultTab == "string" && this.options.defaultTab === o.dataset.tabLink && (n = o, m = this._panel.querySelector(
        `.sidepanel-tab-content[data-tab-content="${this.options.defaultTab}"]`
      )), n && !e.DomUtil.hasClass(n, "active") && (e.DomUtil.addClass(n, "active"), e.DomUtil.addClass(m, "active")), e.DomEvent.on(
        o,
        "click",
        (C) => {
          e.DomEvent.preventDefault(C), e.DomUtil.hasClass(o, "active") || (t.forEach((r) => e.DomUtil.removeClass(r, "active")), e.DomUtil.addClass(o, "active"), s.forEach((r) => {
            o.dataset.tabLink === r.dataset.tabContent ? e.DomUtil.addClass(r, "active") : e.DomUtil.removeClass(r, "active");
          })), this.options.onTabClick(o);
        },
        o
      );
    }), this._toggleButton();
  }
  toggle(a) {
    let t = !0;
    const s = e.DomUtil.hasClass(this._panel, "opened"), o = e.DomUtil.hasClass(this._panel, "closed");
    if (!s && !o ? e.DomUtil.addClass(this._panel, "opened") : !s && o ? (e.DomUtil.addClass(this._panel, "opened"), e.DomUtil.removeClass(this._panel, "closed")) : s && !o ? (t = !1, e.DomUtil.removeClass(this._panel, "opened"), e.DomUtil.addClass(this._panel, "closed")) : e.DomUtil.addClass(this._panel, "opened"), this.options.pushControls) {
      const l = this._map;
      if (l) {
        const n = (l instanceof HTMLElement ? l : l.getContainer()).querySelector(
          ".leaflet-control-container"
        );
        e.DomUtil.addClass(
          n,
          "leaflet-animate-control-container"
        ), t ? (e.DomUtil.removeClass(
          n,
          this.options.panelPosition + "-closed"
        ), e.DomUtil.addClass(
          n,
          this.options.panelPosition + "-opened"
        )) : (e.DomUtil.removeClass(
          n,
          this.options.panelPosition + "-opened"
        ), e.DomUtil.addClass(
          n,
          this.options.panelPosition + "-closed"
        ));
      } else
        console.error(
          "Leaflet.SidePanel: You must add the SidePanel to the map before setting the `pushControls` option."
        );
    }
    this.options.onToggle(t);
  }
  isOpened() {
    return e.DomUtil.hasClass(this._panel, "opened");
  }
  open() {
    this.isOpened() || this.toggle();
  }
  close() {
    this.isOpened() && this.toggle();
  }
  _toggleButton() {
    const a = this._panel.querySelector(
      ".sidepanel-toggle-container"
    ), t = a.querySelector(
      ".sidepanel-toggle-button"
    );
    e.DomEvent.on(
      t,
      "click",
      (s) => {
        this.toggle(s);
      },
      a
    );
  }
}
e.Control.SidePanel = M;
e.control.sidepanel = function(i, a) {
  return new M(i, a);
};
const I = { class: "sidepanel-tab" }, j = ["data-tab-link"], z = /* @__PURE__ */ D({
  __name: "LSidepanelTabNav",
  props: {
    link: {}
  },
  setup(i) {
    return (a, t) => (c(), h("li", I, [
      d("a", {
        href: "#",
        class: "sidebar-tab-link",
        role: "tab",
        "data-tab-link": `tab-${a.link}`
      }, [
        v(a.$slots, "default")
      ], 8, j)
    ]));
  }
}), G = { class: "sidepanel-inner-wrapper" }, J = {
  key: 0,
  class: "sidepanel-tabs-wrapper",
  "aria-label": "sidepanel tab navigation"
}, K = { class: "sidepanel-tabs" }, Q = { class: "sidepanel-content-wrapper" }, R = { class: "sidepanel-content" }, W = /* @__PURE__ */ d("div", { class: "sidepanel-toggle-container" }, [
  /* @__PURE__ */ d("button", {
    class: "sidepanel-toggle-button",
    type: "button",
    "aria-label": "toggle side panel"
  })
], -1), ee = /* @__PURE__ */ D({
  __name: "LSidepanel",
  props: /* @__PURE__ */ U({
    id: {},
    headings: {},
    position: { default: "left" },
    tabsPosition: { default: "top" },
    darkMode: { type: Boolean, default: !1 },
    defaultTab: {},
    pushControls: { type: Boolean, default: !1 }
  }, {
    modelValue: { default: !1, required: !1 },
    modelModifiers: {}
  }),
  emits: /* @__PURE__ */ U(["tabClick"], ["update:modelValue"]),
  setup(i, { emit: a }) {
    const t = w(i, "modelValue");
    V(t, (p) => {
      _.value && (p ? T() : y());
    });
    const {
      id: s,
      headings: o,
      position: l,
      tabsPosition: n,
      darkMode: m,
      defaultTab: C,
      pushControls: r
    } = i, B = a, q = N(), g = k(null), _ = k(null), u = k();
    O(() => {
      var p;
      if (!_.value) return console.error("Panel not found");
      if (g.value = _.value.parentElement, !g.value) return console.error("Map not found");
      u.value = e.control.sidepanel(s, {
        panelPosition: l,
        hasTabs: o && o.length > 0,
        tabsPosition: n,
        darkMode: m,
        defaultTab: C || ((p = o == null ? void 0 : o[0]) == null ? void 0 : p.key),
        pushControls: r,
        onTabClick: (b) => B("tabClick", b),
        onToggle: (b) => t.value = b
      }), u.value.addTo(g.value), t.value ? T() : y();
    });
    const T = () => {
      if (!u.value) return console.error("Panel not found");
      u.value.open(), t.value = !0;
    }, y = () => {
      if (!u.value) return console.error("Panel not found");
      u.value.close(), t.value = !1;
    };
    return (p, b) => (c(), h("div", {
      id: s,
      ref_key: "panel",
      ref: _,
      class: "sidepanel",
      "aria-label": "side panel",
      "aria-hidden": "false"
    }, [
      d("div", G, [
        o && o.length > 0 ? (c(), h("nav", J, [
          d("ul", K, [
            (c(), h(P, null, x(o, (f) => d("li", {
              key: f.key
            }, [
              A(z, {
                link: f.key
              }, {
                default: S(() => [
                  Y(q)[`heading.${f.key}`] ? v(p.$slots, `heading.${f.key}`, { key: 0 }) : (c(), h(P, { key: 1 }, [
                    $(E(f.value), 1)
                  ], 64))
                ]),
                _: 2
              }, 1032, ["link"])
            ])), 64))
          ])
        ])) : L("", !0),
        d("div", Q, [
          d("div", R, [
            v(p.$slots, "default")
          ])
        ])
      ]),
      W
    ], 512));
  }
}), X = ["data-tab-content"], te = /* @__PURE__ */ D({
  __name: "LSidepanelTab",
  props: {
    link: {},
    level: { default: "h3" },
    heading: {}
  },
  setup(i) {
    const { link: a, level: t, heading: s } = i;
    return (o, l) => (c(), h("div", {
      class: "sidepanel-tab-content",
      "data-tab-content": `tab-${a}`
    }, [
      s ? (c(), F(H(t), { key: 0 }, {
        default: S(() => [
          $(E(s))
        ]),
        _: 1
      })) : L("", !0),
      v(o.$slots, "default")
    ], 8, X));
  }
});
export {
  ee as LSidepanel,
  te as LSidepanelTab
};
